/******************* Mitsubishi electric corporation ********************
*                                                                        *
*    Program name    FREQUPS-MINI Service                                *
*                                                                        *
*    Developed by    Information systems department                      *
*                        of                                              *
*                    Mitsubishi electric corporation,Tokyo,Japa          *
*                                                                        *
*    Copyright (C) 2005 Mitsubishi electric corporation                  *
*                                                                        *
*    åȥ΅ʣģԣҡ                                    *
*                                                                        *
*************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <termios.h>
#include <unistd.h>
#include <signal.h>
/************************************************<MOD:05-05-17:start>***/
/* #include <varargs.h> */
#include <stdarg.h>
/************************************************<MOD:05-05-17:e n d>***/
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <sys/uio.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/time.h>
#include "../common/freqship.h"

void GetUpsStat (char *dmn_p, char *pow_p, char *bat_p, long *timerest_p);
int ReadUpsfile ();

char *idf = "/var/run/freqshpd.pid";
char Portname[256];
int Upspow;
int Upsrmt;

/************************************************************************
*    ᥤԤ                                                   *
************************************************************************/
int
main (int argc, char **argv)
{
  unsigned long clr;
  int pd;
  int ret;
  int linestatus;
  char dmn, pow, bat;
  long timerest;
  struct termios termdata;
  char arg_buf[256];
  char arg_buf_wo_p[256];
  char command[266];
  char arg_w_set;

  /* ޥɥ饤ǧʤarg_buf˳Ǽ */
  /* -w ץ¸ߤ halt -w ¹Ԥƽλ */
  /* -p ץ¸ߤե饰򥻥åȤ */
  arg_w_set = 0;
  strcpy(arg_buf, "\0");
  strcpy(arg_buf_wo_p, "\0");
  while (argc > 1)
    {
      if (strcmp("-w", argv[1]) == 0)
	{
	  /* -w ץλ */
	  arg_w_set = 1;
	}
      if (strcmp("-p", argv[1]) != 0)
	{
	  /* -p ץǤʤ */
	  strcat(arg_buf_wo_p, &argv[1][0]);
          strcat(arg_buf_wo_p, " ");
	}
      strcat(arg_buf, &argv[1][0]);      
      strcat(arg_buf, " ");
      argv++;
      argc--;
    }

  if (arg_w_set == 1)
    {
      /* -w ¸ߤ */
      sprintf(command, "halt %s", arg_buf);
      system(command);
      exit(0);
    }

  /* գУӣƣɣ̣ɹ */
  ret = ReadUpsfile ();
  if (ret == 1)
    {
      exit (1);
    }
  /* գУӤΥƥ */
  GetUpsStat (&dmn, &pow, &bat, &timerest);

  /* ãϣͥݡȥץ */
  if ((pd = open (Portname, O_RDWR | O_NDELAY)) < 0)
    {
      exit (1);
    }
  /* λãϣͥݡȥơ³ */
  ret = tcgetattr (pd, &termdata);
  termdata.c_cflag &= ~HUPCL;
  ret = tcsetattr (pd, TCSANOW, &termdata);

  /* ãϣͥݡȤΥꥢ */
  clr = 0;
  if (Upsrmt == 0)
    {
      /* գУӥ⡼ȥåȥθ */
      clr = TIOCM_DTR;
    }
  if (ioctl (pd, TIOCMSET, &clr) < 0)
    {
      exit (1);
    }
  /* ңԣӤ򥻥åȡãԣҤȣģãĤȣˤ */
  clr |= TIOCM_RTS;
  if (ioctl (pd, TIOCMSET, &clr) < 0)
    {
      exit (1);
    }
  sleep (2);
  /* ãϣͥݡȤΥơ */
  if (ioctl (pd, TIOCMGET, &clr) < 0)
    {
      exit (1);
    }
  linestatus = clr & TIOCM_CTS;	/* Ÿ     */

  if (((Upspow == 0) && (!linestatus)) || ((Upspow == 1) && (linestatus)))
    {
      /* գУӥåȥ */
      if (Upsrmt == 0)
	{			/* գУӥ⡼ȥåȥθ */
	  clr &= ~TIOCM_DTR;
	}
      else
	{
	  clr |= TIOCM_DTR;
	}
      if (ioctl (pd, TIOCMSET, &clr) < 0)
	{
	  exit (1);
	}
      sleep (10);

      /* ãϣͥݡȤΥ */
      close (pd);

      sprintf(command, "halt %s", arg_buf_wo_p);
      system(command);
      sleep (10);
    }
  else if (pow == '1')
    {				/* input power restored */
      /* ãϣͥݡȤΥ */
      close (pd);
      system ("reboot -i -d -p");
    }
  else
    {				/* manual shutdown */
      /* ãϣͥݡȤΥ */
      close (pd);
      sprintf(command, "halt %s", arg_buf);
      system(command);
    }

  exit (0);
}

/************************************************************************
*    գУӣƣɣ̣ŤɹߤԤ                                       *
************************************************************************/
int
ReadUpsfile ()
{
  FILE *fp;
  char buff[256];

  /* գУӣƣɣ̣Ťɹ */
  if ((fp = fopen (UPSFILE, "r")) == NULL)
    {
      return (1);
    }
  while (fgets (buff, sizeof (buff), fp))
    {
      if (buff[strlen (buff) - 1] == '\n')
	buff[strlen (buff) - 1] = '\0';

      if (strncmp (buff, "Port=", 5) == 0)
	{
	  strcpy (Portname, &buff[5]);
	}
      else if (strncmp (buff, "Upsbatt=", 8) == 0)
	{
	  Upspow = atoi (&buff[8]);
	}
      else if (strncmp (buff, "Upsrmt=", 7) == 0)
	{
	  Upsrmt = atoi (&buff[7]);
	}
    }
  fclose (fp);

  return (0);
}

/************************************************************
*    գУӤΥƥ                               *
*************************************************************/
void
GetUpsStat (char *dmn_p, char *pow_p, char *bat_p, long *timerest_p)
{
  FILE *fp;
  char buff[1024];
  int cnt;

  /* գУӣӣԣ գУӤΥƥ       */
  if ((fp = fopen (UPSSTAT, "r")) == NULL)
    {
      fprintf (stderr, "\nUPSFILE open error for UPSSTAT\n");
      exit (1);
    }
  while (fgets (buff, sizeof (buff), fp))
    {
      if (buff[strlen (buff) - 1] == '\n')
	buff[strlen (buff) - 1] = '\0';
      if (strncmp (buff, "Daemon=", 7) == 0)
	{
	  *dmn_p = buff[7];
	}
      if (strncmp (buff, "InputPower=", 11) == 0)
	{
	  *pow_p = buff[11];
	}
      if (strncmp (buff, "BatteryStat=", 12) == 0)
	{
	  *bat_p = buff[12];
	}
      if (strncmp (buff, "TimeRest=", 9) == 0)
	{
	  *timerest_p = atol (&buff[9]);
	}
    }
  fclose (fp);
}
